<?php
/**
 * Main menu included in all pages.
 *
 * Note: It is recommended that the main navigation menu follows the example html
 * format (<nav><ul><h2><li><h3><a>) to allow maximum flexibility and compatibility
 * with different themes and their presentation of the main menu, whether it be in
 * the side-bar, a drop-down menu, or an accordion menu.
 *
 * To turn the menu into an accordion menu, add the class "accordion" to menu container.
 * <div class="nav accordion" id="main_menu">
 *  - add "collapsible" to menu container class for a fully collapsible menu.
 *  - set a <ul> tag class to "noaccordion" to remove automation on that section.
 *  - set a <ul> tag class to "expand" to initially expand that section.
 *
 * Note: if template files are accessed locally, (e.g. file:///path/to/local/file.html)
 * it works better if urls below use fully qualified domain names.
 */
?>
<nav><div class="nav" id="main_menu">
<h2>Menu</h2>
<ul>
 <li>
  <h3>Company Links</h3>
  <ul id="company_menu">
   <li><a href="http://amazon.com/" target="_blank">Catalog</a></li>
   <li><a href="https://system.netsuite.com/" target="_blank">Database</a></li>
   <li><a href="https://gmail.com/" target="_blank">WebMail</a></li>
   <li><a href="http://calendars.google.com" target="_blank">Calendars</a></li>
   <li><a href="https://support.examplecompany.com" target="_blank">Support</a></li>
  </ul>
 </li>
 <li>
  <h3>Help/Instructions</h3>
  <ul id="help_menu">
   <li><a href="/home/documentation/">Documentation</a></li>
  </ul>
 </li>
 <li>
  <h3>Department Links</h3>
  <ul id="department_menu">
   <li><a href="/home/sales/">Sales</a></li>
   <li><a href="/home/admin/">Admin</a></li>
  </ul>
 </li>
 <li>
  <h3>User Links</h3>
  <ul id="user_menu">
   <li><a href="/my-account/">My Account</a>
    <ul>
     <li><a href="<?php echo $GLOBALS['MYRA']; ?>/my-info.php">My Information</a></li>
     <li><a href="<?php echo $GLOBALS['MYRA']; ?>/my-files.php">My Files</a></li>
    </ul>
   </li>
  </ul>
 </li>
</ul>
</div><!-- .nav --></nav>
