<?php
/*
 * Unauthorized Error Page (401 errors)
 *
 * Note: Browsers retrieve this program (which is assigned to the Apache directive
 * 401 ErrorDocument) but instead of displaying it they display their login 
 * dialog. If the user cancels then the browser displays this, which has already
 * been retrieved. This behavior is used to work around Safari's signin behavior.
 */

include_once 'myra/lib/config.php';

include_once 'myra/lib/lib.common.php';
debug('401.php: HTTP_USER_AGENT='.$_SERVER['HTTP_USER_AGENT']);

$home_page = '/';
$page_type = 'error';
$body_id = "error401";
$title = 'Authorization Required';
$script = <<<End_Of_Javascript
<script type="text/javascript">if (window.location != top.location) top.location.href=window.location;</script>
End_Of_Javascript;

include 'myra/inc/error_begin.php';
?>

<h1>Authorization Required</h1>

<p>This server could not verify that you are authorized to access the document requested.</p>

<p>You need to provide a valid username and password. Either you supplied the wrong credentials (e.g. a bad password), or there is something wrong with the authorization process preventing this server from authorizing you at this time.</p>

<p>If you believe you arrived here in error and you want to report it, please enter a <a href="<?php echo $GLOBALS['SUPPORT_URL']; ?>?subject=Not%20Authorized%20<?php echo rawurlencode($_SERVER['REQUEST_URI']).'%20for%20'.rawurlencode($GLOBALS['REMOTE_USER']); ?>">support request</a>.</p>

<?php include 'myra/inc/error_end.php'; ?>
