<?php
/*
 * Cancel dialog context
 *
 * This program is intended to be called when a dialog form is canceled.
 * It releases the saved context of a form removing remote posibility that 
 * it could be used as a security breach and to keep session variables small.
 */

include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/class.Session.php';

$session = Session::getInstance();

$key = isset($_REQUEST['key']) ? $_REQUEST['key'] : '';
$keys = is_array($key) ? $key : array($key);

$goodkeys = array(); $badkeys = array();
foreach($keys as $k) {
	if ($k && isset($session->$k)) {
		unset($session->$k);
		$goodkeys[] = $k;
		debug("Canceling key $k");
	}
	else {
		$badkeys[] = $k;
	}
}

$msg = '';
if (count($badkeys) > 0) {
	$msg = 'Context does not exist for ' . join(', ',$badkeys) . '.';
}
if (count($goodkeys) > 0) {
	exit_result(true,$msg);
}
else {
	exit_result(false,$msg);
}
?>
