<?php
/*
 * Close uploads
 *
 * This program gets called after file uploads. It releases the context key and it
 * emails the list of files uploaded to an address if specified in the index database.
 */

include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.index.php';

$session = Session::getInstance();

$key = isset($_POST['key']) ? $_POST['key'] : '';
$files = isset($_POST['files']) ? $_POST['files'] : array();
$files = is_array($files) ? $files : array($files);

if (switch_context_to_key($key)) {	// don't preserve key here thereby releasing it
	debug("close_upload: files uploaded: ".join(", ",$files));
	if (count($files) > 0) {
		index_upload_notify($session->curr_dir,$files);
	}
	exit_result(true);
}
exit_result(false,"Context does not exist for $key.");
?>
