<?php
/*
 * Delete a file
 *
 * Intended for ajax usage only. Current file obtained from session variables.
 * This deletes the thumbnail and slide if the file is a picture.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/class.IndexDb.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';
include_once 'myra/lib/lib.file.php';

$session = Session::getInstance();

$key = isset($_POST['key']) ? $_POST['key'] : null;

switch_context_to_key($key) or exit_forbidden();

$filename = $session->curr_file;
if (! $filename) {
	warn(basename(__FILE__).": file to delete not specified in session. request_uri: {$_SERVER['REQUEST_URI']}");
	exit_result(false,"File name was not specified.");
}

$file = $session->curr_dir.DIRECTORY_SEPARATOR.$filename;
if (! file_exists($file)) {
	warn(basename(__FILE__).": file to delete does not exists. request_uri: {$_SERVER['REQUEST_URI']}");
	exit_result(false,"File does not exist.");
}

$view_start_time = (isset($_POST['time']) && $_POST['time']) ? $_POST['time'] : $session->view_start_time;

clearstatcache();
if (filemtime($file) > $view_start_time) {
	exit_result(false,"The file has changed since you started viewing it. Please refresh your screen and try again.");
}

if (bool($_REQUEST['confirm'])) {
	archive_file($file,$session->user->username().": Before removing file from the web. ({$_SERVER['REMOTE_ADDR']})");

	$idb = new IndexDb($session->curr_dir);
	$idb->remove($filename);

	if(delete_file($file)) {
		$data = array();
		$data['filename'] = $filename;
		$data['msg'] = "$filename deleted.";
		exit_result(true,$data);
	}
	else {
		exit_result(false,"$filename was NOT deleted.");
	}
}
else {
	exit_result(false,"File deletion was not confirmed, so the file \"$filename\" was NOT deleted.");
}
exit;
?>
