<?php
/*
 * Delete a slide
 *
 * This deletes an image, its thumbnail and its slide.
 * Intended for ajax usage only.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/class.IndexDb.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';
include_once 'myra/lib/lib.file.php';

$session = Session::getInstance();

is_ajax_request() or exit_forbidden();
if (context_id($_SERVER['HTTP_REFERER']) != $session->context) {
        switch_context($_SERVER['HTTP_REFERER']) or exit_forbidden();
}
can_edit_current_dir() or exit_forbidden();

$filename = isset($_GET['file']) ? rawurldecode($_GET['file']) : $session->curr_file;

if (preg_match('|\.\./|',$filename)) {
	echo "File was NOT deleted.";
	trigger_error("Relative path names using /../ are not allowed. file=$filename",E_USER_ERROR);
}

$file = $session->curr_dir.DIRECTORY_SEPARATOR.$filename;

if (! file_exists($file)) {
	warn(basename(__FILE__).": file to delete does not exists. request_uri: {$_SERVER['REQUEST_URI']}");
	echo "File does not exist.";
	exit;
}

if (filemtime($file) > $session->view_start_time) {
	echo "File has changed since you started viewing it.";
	exit;
}

if (bool($_GET['confirm'])) {
	// Uncomment next to archive slides before deleting.
	//archive_file($file,$session->user->username().": Before removing file from the web. ({$_SERVER['REMOTE_ADDR']})");

	$idb = new IndexDb($session->curr_dir);
	$idb->remove($filename);

	if(delete_file($file)) {
		echo "File deleted.";		// required phrase for success
	}
	else {
		echo "File was NOT deleted.";
	}
}
else {
	echo "File deletion was not confirmed, so the file \"$filename\" was NOT deleted.";
}
exit;
?>
