<?php
/*
 * Get context key
 *
 * Get a context key to be used to edit a file.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';

authenticate_user() or die_unauthenticated();

$session = Session::getInstance();
if (context_id($_SERVER['HTTP_REFERER']) != $session->context) {
	switch_context($_SERVER['HTTP_REFERER']) or exit_forbidden();
}

can_edit_current_file() or exit_forbidden();

$file = $session->curr_dir.DIRECTORY_SEPARATOR.$session->curr_file;
$view_start_time = (isset($_GET['t']) && $_GET['t']) ? $_GET['t'] : $session->view_start_time;

clearstatcache();
if (filemtime($file) > $view_start_time) {
	exit_result(false,"The file has changed since you started viewing it. Please refresh your screen and try again.");
}

$key = new_context();

exit_result(true,array(key=>$key));
?>
