<?php
/*
 * Rename a file
 *
 * Intended for ajax usage only. Current file obtained from session variables.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/class.IndexDb.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';
include_once 'myra/lib/lib.file.php';

$session = Session::getInstance();

is_ajax_request() or exit_forbidden();
if (context_id($_SERVER['HTTP_REFERER']) != $session->context) {
        switch_context($_SERVER['HTTP_REFERER']) or exit_forbidden();
}
can_edit_current_dir() or exit_forbidden();

$filename = isset($_POST['filename']) ? $_POST['filename'] : $session->curr_file;
$newname  = isset($_POST['newname'])  ? $_POST['newname']  : '';

if (! $filename) {
	warn(basename(__FILE__).": no file name specified to rename. request_uri: {$_SERVER['REQUEST_URI']}");
	exit;
}

if (! $newname) {
	warn(basename(__FILE__).": no new file name specified to rename. request_uri: {$_SERVER['REQUEST_URI']}");
	exit;
}

if (preg_match('|'.DIRECTORY_SEPARATOR.'|',$filename)) {
	echo $filename;
	trigger_error("File names containing ".DIRECTORY_SEPARATOR." characters are not allowed. file=$filename",E_USER_ERROR);
}

chdir($session->curr_dir);

if (! file_exists($filename)) {
	warn(basename(__FILE__).": file to rename does not exists. request_uri: {$_SERVER['REQUEST_URI']}");
	echo $filename;
	exit;
}

// Preserve original file extension if newname does not have one.
if (! extension($newname)) {
	$ext = extension($filename);
	if ($ext) $newname .= ".$ext";
}

if (rename_file($filename,$newname)) {
	$idb = new IndexDb($session->curr_dir);
	$idb->rename($filename,$newname);
	echo $newname;
}
else {
	echo $filename;
}
exit;
?>
