<?php
/*
 * Save a file
 *
 * Intended for ajax usage only. Current file obtained from session variables.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';
include_once 'myra/lib/lib.file.php';

$session = Session::getInstance();

is_ajax_request() or exit_forbidden();

$key	 = isset($_POST['key'])		? $_POST['key']		: null;
$content = isset($_POST['content'])	? $_POST['content']	: '';

switch_context_to_key($key) or exit_forbidden();

can_edit_current_file() or exit_forbidden();

$file = $context['curr_dir'].DIRECTORY_SEPARATOR.$context['curr_file'];

// Uncomment the following to sanitize content.
$content = sanitize_php($content);

if (! $content) {
	warn(basename(__FILE__).": no content to save to $file. request_uri: {$_SERVER['REQUEST_URI']}");
	exit_result(false,"Content was empty.");
}

if (filemtime($file) > $context['view_start_time']) {
	exit_result(false,"File has changed since you started viewing it.");
}

$old = file_get_contents($file);
$new = $content;
if (strlen($new) > 0 && strcmp($new,$old) != 0) {
	archive_file($file,"Before being saved from web by: ".$session->user->username()." ({$_SERVER['REMOTE_ADDR']})");
	write_file($file,$new) or exit_result(false,"Error writing file.");

	$session->view_start_time = time();	// reset
	exit_result(true,"File saved.");
}
else {
	exit_result(false,"No changes were made.");
}
?>
