<?php
/*
 * Return template parts to myra.template.js script for it to wrap around the body of an html file.
 *
 * Intended for ajax usage only.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';
include_once 'myra/lib/lib.file.php';

// Note: check _GET as JSONP does not work with POST method. (jsonp is used to handle file:/// urls).
$location	  = isset($_POST['l'])	? $_POST['l']		: null or
 $location	  = isset($_GET['l'])	? $_GET['l']		: null;
$template	  = isset($_POST['t'])	? $_POST['t']		: null or
 $template	  = isset($_GET['t'])	? $_GET['t']		: $GLOBALS['MYRA_TEMPLATE'];
$callback	  = isset($_GET['callback'])	? $_GET['callback']	: null;

$scheme = parse_url($location,PHP_URL_SCHEME);

is_ajax_request() or
 ($scheme == 'file' && (!isset($_SERVER['HTTP_REFERER']) || $_SERVER['HTTP_REFERER'] == $location)) or
 exit_forbidden();

if (! isset($_COOKIE[session_name()]) && ! bool($_REQUEST['start'])) {
	// Note: ajax programs do not have an ability to set cookies for the invoking page
	// so we pass back a url to redirect to so that a php session can be setup before
	// being redirected back to here. This should be only a one-time event. It allows
	// urls to be embedded in email messages and such. A token is added to validate
	// us to the start.php program.

	exit_result(false,array(href=>my_scheme()."://{$_SERVER['SERVER_NAME']}{$GLOBALS['MYRA']}/start.php?r={$_SERVER['HTTP_REFERER']}&t=".token($_SERVER['HTTP_REFERER'])),$callback);
}

if (! $location) {
	security("Bad location '$location'");
	exit_result(false,array(href=>my_scheme()."://{$_SERVER['SERVER_NAME']}{$GLOBALS['MYRA']}/404.php"),$callback);
}

$session = Session::getInstance();

$user = authenticate_user() or die_unauthenticated();

// Being this is an ajax program working on a location that is passed to it as an argument,
// there is not any trust that $location is in fact the document actually being worked on.
// To gain trust that we have security clearances, check if there is a context saved in the
// session that proves the directory containing the location has been visited and therefore
// has passed security.
// TODO: deal with case where containing directory has a custom index.php.
$dir_url = preg_replace('|(.*/).*|','$1',$location);	// url of $location's directory
context_exists($dir_url) or $scheme == 'file' or exit_forbidden();

// To gain trust that we have security clearances, redirect to the directory containing $location
// where, unless there is a custom index.php, the myra/inc/index_begin.php program will intercept
// and redirect back to here if security is passed. This allows urls to be emailed that can be just clicked.
// TODO: Rethink following. Even with tokens, we will be redirecting to an arbitrary hard to clean url here.
//$tok = token('MysterY' . strval(time()) . $_SERVER['REMOTE_ADDR'] . strval(random(5)) . $location);

$template = sanitize_template_name($template);

save_template_context($location);		// for ajax edits

// Set template variables
$GLOBALS['Template'] = $template;
$GLOBALS['Theme'] = my_theme();
$GLOBALS['URL'] = $_SERVER['HTTP_REFERER'];
$GLOBALS['File'] = $session->curr_dir.DIRECTORY_SEPARATOR.$session->curr_file;

include_once 'myra/lib/class.TemplateParts.php';	// include now we know which template
$tp = new TemplateParts($template);

exit_result(true, array(
	'orientation'	=> $tp->orientation(),
	'head'		=> $tp->head(),
	'scripts'	=> $tp->scripts(),
	'beforeBody'	=> $tp->beforeBodyHTML(),
	'afterBody'	=> $tp->afterBodyHTML()
),$callback);
?>
