<?php
/*
 * List available themes with links to change current theme.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/lib.common.php';

$title = "Change Display Theme";
?>
<?php include 'myra/inc/portrait_begin.php'; ?>

<h1>Change Display Theme</h1>

<p>Select one of the buttons below to change your display theme.
<br/>Your current theme is the theme below with a box around it.</p>

<ul class="themes">
<?php
$mytheme = my_theme();
foreach (theme_list() as $themeinfo) {
	list ($theme,$themename) = $themeinfo;
	$class = $theme == $mytheme ? ' class="active"' : '';
	$description = preg_replace('/\s$/','',file_get_contents("{$GLOBALS['MYRA_THEMES_PATH']}/$theme/description.html"));
	print <<< End_Of_HTML
 <li$class><a href="?theme=$theme$i"><img src="{$GLOBALS['MYRA_THEMES']}/$theme/icon.png" alt="$themename" /><div>
$description
</div></a></li>

End_Of_HTML;
}
?>
</ul>

<?php include 'myra/inc/portrait_end.php'; ?>
