<?php
include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.index.php';
include_once 'myra/lib/lib.auth.php';

authenticate_user() or die_unauthenticated();

$session = Session::getInstance();
if (context_id($_SERVER['HTTP_REFERER']) != $session->context) {
        switch_context($_SERVER['HTTP_REFERER'])
	 or exit_dialog_error("Could not obtain permission for this operation. Please refresh your screen and try again.");
}
can_upload_to_current_dir() or exit_forbidden();

$title = "File Uploader";
$page_type = 'dialog';
$link = '<link href="css/fileUploader.css" rel="stylesheet" type="text/css" />';
$script = '<script src="js/jquery.fileUploader.js" type="text/javascript"></script>';
 
$max_size = min(intval(ini_get('upload_max_filesize')),intval(ini_get('post_max_size')),intval(ini_get('memory_limit')));
$maxstr = $max_size ? " <small>Maximum size: {$max_size}MB</small>" : '';
?>
<?php include 'myra/inc/dialog_preamble.php'; ?>
<div id="main_container">
<h1>File Upload<?php echo $maxstr; ?></h1>
<form action="upload.php" method="post" enctype="multipart/form-data">
<input type="submit" value="Upload" id="pxUpload" disabled="disabled" />
<input type="reset" value="Clear" id="pxClear" disabled="disabled" />
<input id="uploader" name="userfile" type="file" />
</form>
<script type="text/javascript">
jQuery(function($){
	$('#uploader').fileUploader({
		limit: 20,
		imageLoader: 'img/image_upload.gif',
		allowedExtension: '<?php echo index_upload_file_types(); ?>',
		context: '<?php echo new_context(); ?>'
	});

	// Allow esc key to close dialog.
	$(document).keyup(function(e){ if (e.which == 27) parent.jQuery.fancybox.close(); });
});
</script>
</div><!-- #main_container -->
<?php include 'myra/inc/dialog_epilog.php'; ?>
