/*
*	Class: fileUploader
*	Use: Upload multiple files the jQuery way
*	Author: John Lanz (http://pixelcone.com)
*	Version: 1.0
*
* 11/15/2011 mack at mackpexton.com
* Adapted to Myra by adding security context keys to forms.
* @requires myra.js
*/

(function($) {
	$.fileUploader = {version: '1.1'};
	$.fn.fileUploader = function(config){
		
		config = $.extend({}, {
			limit: '',
			imageLoader: '',
			buttonUpload: '#pxUpload',
			buttonClear: '#pxClear',
			successOutput: 'File uploaded',
			errorOutput: 'Failed',
			inputName: 'userfile',
			inputSize: 30,
			allowedExtension: 'jpg|jpeg|gif|png',
			callback: function() {
				
			}
		}, config);
		
		parent.myra.startUpload(config.context);

		var itr = 0, //number of files to uploaded
		$limit = 1;

		//public function
		$.fileUploader.change = function(e){
			var fname = px.validateFile( $(e).val() );
			if (fname == -1){
				//alert ("Invalid file!");
				alert ("Sorry, security restrictions prevent this type of file to be uploaded here.");
				$(e).val("");
				return false;
			}
			$('#px_button input').removeProp("disabled");
			var imageLoader = $.trim(config.imageLoader) != '' ? '<img src="'+ config.imageLoader +'" alt="uploader" />' : '',
			display = '<div class="uploadData pending" id="pxupload'+ itr +'_text" title="pxupload'+ itr +'">' + 
				'<div class="close">&nbsp;</div>' +
				'<span class="fname">'+ fname +'</span>' +
				'<span class="loader" style="display:none">'+ imageLoader +'</span>' +
				'<div class="status">Pending...</div></div>';
			
			$("#px_display").append(display);
			if (config.limit == '' || $limit < config.limit) {
				px.appendForm();
			}
			$limit++;
			$(e).hide();
		}
		
		$(config.buttonUpload).click(function(){
			if (itr > 1){
				$('#px_button input').prop("disabled",true);
				$("#pxupload_form form").each(function(){
					e = $(this);
					var id = "#" + $(e).prop("id"),
					input_id = id + "_input",
					input_val = $(input_id).val();
					if (input_val != ""){
						$(id + "_text .status").text("Uploading...");
						$(id + "_text").removeClass('pending').addClass('running');
						$(id + "_text .loader").show();
						$(id + "_text .close").hide();
						
						$(id).submit();
						$(id +"_frame").load(function(){
							$(id + "_text .loader").hide();
							up_output = $(this).contents().find("#output").text();
							if (up_output == "success"){
								$(id + "_text").removeClass('running').addClass('success');
								up_output = config.successOutput;
								parent.myra.registerUpload(input_val);
								parent.myra.scheduleRefresh();
							}else{
								$(id + "_text").removeClass('running').addClass('error');
								up_output = config.errorOutput;
							}
							up_output += '<br />' + $(this).contents().find("#message").text();
							$(id + "_text .status").html(up_output);
							$(e).remove();
							$(config.buttonClear).removeProp("disabled");
							config.callback($(this));
						});
					}
				});
			}
		});
		
		$(".close").live("click", function(){
			$limit--;
			if ($limit == config.limit) {
				px.appendForm();
			}
			var id = "#" + $(this).parent().prop("title");
			$(id+"_frame").remove();
			$(id).remove();
			$(id+"_text").fadeOut("slow",function(){
				$(this).remove();
			});
			parent.myra.releaseKey($(id+' input[name=key]').val());
			return false;
		});
		
		$(config.buttonClear).click(function(){
			parent.myra.releaseKeys();
			$("#px_display").fadeOut("slow",function(){
				$("#px_display").html("");
				$("#pxupload_form").html("");
				itr = 0;
				$limit = 1;
				px.appendForm();
				$('#px_button input').prop("disabled",true);
				$(this).show();
			});
		});

		$(window).unload(function(){
			if (window == parent.window) {
				// not a dialog, cleanup here
				// 12/2011 Chrome does not call the unload function (!!)
				myra.releaseKeys();
				myra.closeUpload();
			}
		});
		
		//private function
		var px = {
			init: function(e){
				var form = $(e).parents('form');
				px.formAction = $(form).prop('action');
				$(form).before(' \
					<div id="pxupload_form"></div> \
					<div id="px_display"></div> \
					<div id="px_button"></div> \
				');
				$(config.buttonUpload+','+config.buttonClear).appendTo('#px_button');
				if ( $(e).prop('name') != '' ){
					config.inputName = $(e).prop('name');
				}
				if ( $(e).prop('size') != '' ){
					config.inputSize = $(e).prop('size');
				}
				$(form).hide();
				this.appendForm();
			},
			appendForm: function(){
				itr++;
				var formId = "pxupload" + itr,
				iframeId = "pxupload" + itr + "_frame",
				inputId = "pxupload" + itr + "_input",
				// Must get Myra context key before files can be saved.
				contents, errmsg = '<p class="error">Cannot get permission to upload from the server. Please refresh this page and try again.</p>';
				$.ajax({
					type: 'POST',
					url: myra.cfg('ajax')+'/getuploadkey.php',
					data: {context:config.context},
					dataType: 'json'
				})
				.done(function(result){
					if (result['success']) {
						parent.myra.registerKey(result.data.key);
						contents = '' +
'<form method="post" id="'+ formId +'" action="'+ px.formAction +'" enctype="multipart/form-data" target="'+ iframeId +'">' +
'<input type="hidden" name="key" value="' + result.data.key + '" />' +
'<input type="file" name="'+ config.inputName +'" id="'+ inputId +'" class="pxupload" size="'+ config.inputSize +'" onchange="$.fileUploader.change(this);" />' +
'</form>' + 
'<iframe id="'+ iframeId +'" name="'+ iframeId +'" src="about:blank" style="display:none"></iframe>';
					}
					else {
						contents = errmsg;
					}
					$("#pxupload_form").append( contents );
				})
				.fail(function(){
					$("#pxupload_form").append( errmsg );
				});

			},
			validateFile: function(file) {
				if (file.indexOf('/') > -1){
					file = file.substring(file.lastIndexOf('/') + 1);
				}else if (file.indexOf('\\') > -1){
					file = file.substring(file.lastIndexOf('\\') + 1);
				}
				//var extensions = /(.jpg|.jpeg|.gif|.png)$/i;
				//var extensions = new RegExp(config.allowedExtension + '$', 'i');
				var extensions = new RegExp('\\.(' + config.allowedExtension + ')$', 'i');
				if (extensions.test(file)){
					return file;
				} else {
					return -1;
				}
			}
		}
		
		px.init(this);
		
		return this;
	}
})(jQuery);
