<?php
/**
 * HTML5 Page Header
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/lib.common.php';

// Global Arguments
global $body_id, $title, $description, $theme;		// Text describing this page
global $meta, $link, $style, $script;			// Additional HTML tags
global $page_type,$orient;				// Application Arguments

// Default values
$body_id 	= isset($body_id)	? $body_id	: ""; ###'pg_'.preg_replace('/\W+/','_',pathinfo($_SERVER['PHP_SELF'],PATHINFO_FILENAME));
$title		= isset($title)		? $title	: $GLOBALS['PAGE_TITLE'];
$description	= isset($description)	? $description	: "";

$meta		= isset($meta)		? $meta		: "";
$link		= isset($link)		? $link		: "";
$style		= isset($style)		? $style	: "";
$script		= isset($script)	? $script	: "";

// Brand title with company name
$page_title = "$title - {$GLOBALS['ORG_NAME']}";

// Page_type essentially determines which primary css file to use.
// To make a new page_type, simply define a new <page_type>.css file in the theme's css directory.
$page_type	= isset($page_type)	? $page_type	: "page";

// Themes are saved in a cookie or can be specified in url parameters.
$theme		= isset($theme)		? $theme	: my_theme();

// Orient deterimines the page orientation, portrait or landscape.
$orient		= isset($orient)	? $orient	: '';
if (! $orient && isset($_COOKIE['myraOrient'])) $orient = $_COOKIE['myraOrient'] == 'L' ? 'landscape' : 'portrait';

////////////////////////////////////////
?>
<!doctype html>
<html lang="en-US" xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php echo $page_title; ?></title>
<?php if ($description) echo "<meta name=\"description\" content=\"$description\" />\n"; ?>
<meta charset="utf-8" />
<meta name="copyright" content="© <?php echo date("Y"); ?> <?php echo $GLOBALS['ORG_NAME']; ?>, <?php echo $GLOBALS['ORG_URL']; ?>" />
<?php if ($meta) echo $meta."\n"; ?>
<link rel="icon" href="/favicon.ico" />
<?php include 'myra/inc/myra_preamble.php'; ?>
<link rel="stylesheet" type="text/css" media="all" href="<?php echo $GLOBALS['MYRA_THEMES']; ?>/<?php echo rawurlencode($theme); ?>/css/<?php echo $page_type; ?>.css" title="<?php echo htmlspecialchars($theme); ?>" />
<?php if ($link) echo $link."\n"; ?>
<?php if ($style) echo $style."\n"; ?>
<script src="<?php echo $GLOBALS['MYRA_THEMES']; ?>/<?php echo rawurlencode($theme); ?>/js/myra.page.js"></script>
<?php if ($script) echo $script."\n"; ?>
</head>
<?php flush(); // recommended by http://developer.yahoo.com/performance/rules.html ?>
<body<?php echo $body_id ? ' id="'.$body_id.'"' : ''; ?><?php echo $orient ? ' class="'.$orient.'"' : ''; ?>>
