<?php
/**
 * Header file used with Apache mod_autoindex.
 *
 * This is automatically inserted into the header pages generated by the Apache webserver.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';
include_once 'myra/lib/lib.index.php';

if (! isset($_COOKIE[session_name()]) && ! bool($_REQUEST['start'])) {
	// Note: mod_autoindex thwarts sending header records from here which thwarts setting
	// cookies like the php session cookie. When the mod_autoindex page is the first page
	// rendered, we redirect to a page which sets the php session cookie and then that
	// page redirects us back here so session variables are valid. This should be only a
	// one-time event and allows urls to be embedded in email messages.

	// Note: cannot stop mod_autoindex from printing list of files, so just hide them
	// till redirect.

	// Note: IE8&9 do not set HTTP_REFERER on first call, so return url is an argument
	// to the start.php program, which appends a "start=1" argument to the url to use for
	// loop prevention.

	// Note: if the target directory requires a login, the way browsers download the 401
	// page before presenting the login screen upsets the determination of whether the url
	// getting here is a https:// or http:// as the 401 page is retreived with a http:// url.

	$return_url = rawurlencode(my_url());
	$token = token(my_url());
	print <<<End_Of_HTML
<html><head><meta http-equiv="refresh" content="0; url={$GLOBALS['MYRA']}/start.php?r={$return_url}&t={$token}"><style>body{display:none;}</style></head><body>
End_Of_HTML;
	exit;
}

$user = authenticate_user() or die_unauthenticated();

global $page_type, $body_id, $title, $meta;
$page_type = 'index';
$body_id = 'index';
$title = index_title() or $title = basename(rawurldecode(preg_replace('/\?.*/','',$_SERVER['REQUEST_URI']))).' index';
$meta = index_meta();
?>
<?php include 'myra/inc/html5_preamble.php'; ?>
<div class="page">
<?php include 'myra/inc/page_buttons.php'; ?>

<?php include 'myra-local/inc/index_header.php'; ?>

<div class="content">
<?php include 'myra/inc/index_buttons.php'; ?>
<?php include_index_header(); ?>

<div class="file-list">
