<?php
/*
 * Myra Include file
 *
 * This file should be included into the <head></head> portion of each page rendered.
 * It should be included just before other script tags.
 */

## TODO: Change myra javascripts to minified versions.

include_once 'myra/lib/config.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';
include_once 'myra/lib/lib.index.php';

save_context();		// for ajax

global $page_type;
$need_fancybox = $page_type == 'index' || can_edit_current_dir();	// for pics or dialogs

if ($need_fancybox) {
	echo '<link rel="stylesheet" href="/myra/js/jquery.fancybox-1.3.4/fancybox/jquery.fancybox-1.3.4.css" type="text/css" />'."\n";
}

if ($page_type == 'index' &&
   ((isset($_COOKIE['myraView']) && $_COOKIE['myraView'] == 'thumb') ||
    (!isset($_COOKIE['myraView']) && is_gallery_default_view()))) {
	// Thumbnail view, initially hide file list to keep view from jumping.
	echo "<style>.file-list { display:none; }</style>\n";
}

// Common libraries

echo <<<End_Of_HTML
<script src="{$GLOBALS['MYRA']}/js/jquery.min.js"></script>
<script src="{$GLOBALS['MYRA']}/js/jquery.cookie.min.js"></script>

End_Of_HTML;

if ($need_fancybox) {
	echo <<<End_Of_HTML
<script src="{$GLOBALS['MYRA']}/js/jquery.fancybox-1.3.4/fancybox/jquery.easing-1.3.pack.js"></script>
<script src="{$GLOBALS['MYRA']}/js/jquery.fancybox-1.3.4/fancybox/jquery.mousewheel-3.0.4.pack.js"></script>
<script src="{$GLOBALS['MYRA']}/js/jquery.fancybox-1.3.4/fancybox/jquery.fancybox-1.3.4.js"></script>

End_Of_HTML;
}
if ($page_type == 'index' && can_rearrange_current_dir()) {
	echo <<<End_Of_HTML
<script src="{$GLOBALS['MYRA']}/js/jquery.dragsort.min.js"></script>

End_Of_HTML;
}

// Myra libraries

switch ($page_type) {
case 'index':
	echo <<<End_Of_HTML
<script>window.MYRA='{$GLOBALS['MYRA']}';</script>
<script src="{$GLOBALS['MYRA']}/js/myra.js"></script>
<script src="{$GLOBALS['MYRA']}/js/myra.index.js"></script>

End_Of_HTML;

	if (can_edit_current_dir()) {
		echo <<<End_Of_HTML
<script>
jQuery(function($){
	$('a.icon-page-new').fancybox({
		'type'			: 'iframe',
		'width'			: 600,
		'height'		: 380,
		'autoScale'		: false,
		'hideOnOverlayClick'	: false,
		'titleShow'		: false,
		'onClosed'		: function(){myra.dialogCleanup()}
	});
	$('a.icon-folder-new').fancybox({
		'type'			: 'iframe',
		'width'			: 660,
		'height'		: 410,
		'autoScale'		: false,
		'hideOnOverlayClick'	: false,
		'titleShow'		: false,
		'onClosed'		: function(){myra.dialogCleanup()}
	});
	$('a.icon-edit').fancybox({
		'type'			: 'iframe',
		'width'			: 660,
		'height'		: 410,
		'autoScale'		: false,
		'hideOnOverlayClick'	: false,
		'titleShow'		: false,
		'onClosed'		: function(){myra.dialogCleanup()}
	});
});
</script>

End_Of_HTML;
	}

	if (can_upload_to_current_dir()) {
		echo <<<End_Of_HTML
<script>
jQuery(function($){
	$('a.icon-upload').fancybox({
		'type'			: 'iframe',
		'width'			: 500,
		'height'		: 350,
		'autoScale'		: false,
		'hideOnOverlayClick'	: false,
		'titleShow'		: false,
		'onClosed'		: function(){myra.dialogCleanup()}
	});
});
</script>

End_Of_HTML;
	}

	// Stream movies if on PC. Mobile devices need to install viewers themselves.
	if (! is_mobile_device()) {
		echo <<<End_Of_HTML
<script>
jQuery(function($){
	var frame_h = 35, frame_w = 25;
	$('a[href$=".mp4"],a[href$=".MP4"],'
	+ 'a[href$=".mov"],a[href$=".MOV"],'
	+ 'a[href$=".m4v"],a[href$=".M4V"],'
	+ 'a[href$=".3gp"],a[href$=".3GP"],'
	+ 'a[href$=".avi"],a[href$=".AVI"],'
	+ 'a[href$=".wmv"],a[href$=".WMV"],'
	+ 'a[href$=".swf"],a[href$=".SWF"]',
	+ 'a[href$=".flv"],a[href$=".FLV"]',
	+ 'a[href$=".f4v"],a[href$=".F4V"]'
	).stream().fancybox({
		'type'			: 'iframe',
		'width'			: 640+frame_w,
		'height'		: 360+frame_h,
		'autoScale'		: true,
		'hideOnOverlayClick'	: false,
		'titleShow'		: false
	});
});
</script>

End_Of_HTML;
	}

	include_index_order();

	if (!isset($_COOKIE['myraView']) && is_gallery_default_view()) {
		echo "<script>jQuery(function(){myra.changeToThumbView()})</script>\n";
	}

	break;


// All other page_types
default:
	if (can_edit_current_file() || can_delete_current_file()) {
		$server_time = time();

		echo <<<End_Of_HTML
<script>window.MYRA='{$GLOBALS['MYRA']}';</script>
<script>window.TIME=$server_time;</script>
<script src="{$GLOBALS['MYRA']}/js/myra.js"></script>

End_Of_HTML;

		if (can_edit_current_file()) {
			// Immediately edit file if ?edit=yes in url
			if (bool($_GET['edit'])) {
				$editnow = '.done(function(){myra.editPage();})';
			} 

			echo <<<End_Of_HTML
<script>
jQuery(function($){
	if ($('.editable').length > 0) {
		$.ajax({dataType: 'script', cache: true, url: '{$GLOBALS['MYRA']}/js/myra.editpage.js'})$editnow;
	}
	else {
		$('a.icon-edit').hide();
	}
});
</script>

End_Of_HTML;
		}

		if (can_delete_current_file()) {
			### echo <<<'End_Of_HTML' ### TODO: change to nowdoc in PHP 5.3, icon -> $icon
			echo <<<End_Of_HTML
<script>
jQuery(function($){
	$('a.icon-delete')
	.each(function(){
		var icon = $(this);
		icon
		.prop('href',icon.prop('href')+'?time='+myra.time())
		.click(function(){
			icon.prop('href',icon.prop('href').replace(/time=\d+/,'time='+myra.time()));
		});
	})
	.fancybox({
		'type'			: 'iframe',
		'width'			: 500,
		'height'		: 350,
		'autoScale'		: false,
		'hideOnOverlayClick'	: false,
		'titleShow'		: false,
		'onClosed'		: function(){myra.dialogCleanup()}
	});
});
</script>

End_Of_HTML;
		}
	}
	else {
		// Read only files
		echo <<<End_Of_HTML
<script>window.MYRA='{$GLOBALS['MYRA']}';</script>
<script src="{$GLOBALS['MYRA']}/js/myra.js"></script>

End_Of_HTML;
	}
}//switch
?>
