<?php
/**
 * HTML template scripts.
 * These scripts are included and executed in HTML template files.

 * This output was intended to be inserted between the <head></head> tags but
 * that triggered scripts to be retrieved using ajax and that is over 2x slower
 * than adding scripts to the body with innerHTML so this was separated from 
 * template_head.php.
 *
 * TODO: Change myra javascripts to minified versions.
 */

include_once 'myra/lib/config.php';

// Global Arguments
global $theme;

$theme = isset($theme) ? $theme : 'default';
$encoded_theme = rawurlencode($theme);

$server_time = time();

if (can_edit_current_file()) {
	// Immediately edit file if ?edit=yes in url
	if (preg_match('/[?&]edit=(yes|y|1)\\b/i',$_SERVER['HTTP_REFERER'])) {
		$editnow = '.done(function(){myra.editPage()})';
	} 

	$edit_script = <<<End_Of_Javascript

	$(document).one('documentReady',function(){
		if ($('.editable').length > 0) {
			$.ajax({url:BASE+'/js/myra.editpage.js',dataType: 'script', cache: true, async:true})$editnow;
		}
		else {
			$('.icon-edit').hide();
		}
	});

End_Of_Javascript;

	$delete_script = <<<End_Of_Javascript

	.done(function(){
		$(document).one('documentReady',function(){
			$('a.icon-delete')
			.each(function(){
				var icon = $(this);
				icon
				.prop('href',icon.prop('href')+'?time='+window.TIME)
				.click(function(){
					icon.prop('href',icon.prop('href').replace(/time=\d+/,'time='+myra.time()));
				});
			})
			.fancybox({
				'type'			: 'iframe',
				'width'			: 500,
				'height'		: 350,
				'autoScale'		: false,
				'hideOnOverlayClick'	: false,
				'titleShow'		: false,
				'onClosed'		: function(){myra.dialogCleanup()}
			});
		});
	})

End_Of_Javascript;
}

//
// Dynamically load scripts
//

echo <<<End_Of_Javascript
(function($){
	$.ajax({url:BASE+'/js/jquery.cookie.min.js',dataType:'script',cache:true,async:true});
	$.ajax({url:BASE+'/js/jquery.fancybox-1.3.4/fancybox/jquery.easing-1.3.pack.js',dataType:'script',cache:true,async:true});
	$.ajax({url:BASE+'/js/jquery.fancybox-1.3.4/fancybox/jquery.mousewheel-3.0.4.pack.js',dataType:'script',cache:true,async:true});
	$.ajax({url:BASE+'/js/jquery.fancybox-1.3.4/fancybox/jquery.fancybox-1.3.4.js',dataType:'script',cache:true,async:true})$delete_script;

	window.MYRA='{$GLOBALS['MYRA']}';
	window.TIME = $server_time;
	$.ajax({url:BASE+'/js/myra.js',dataType:'script',cache:true,async:false})
	.done(function() {
		$.ajax({url:myra.cfg('themes')+'/$encoded_theme/js/myra.page.js',dataType:'script',cache:true,async:true});
                $(document).one('documentReady',function(){
                        if ($('body').hasClass('landscape')) myra.setLandscapeWidth();
                });
	});
$edit_script
})(jQuery);

End_Of_Javascript;
?>
