/**
 * Scripts for index pages
 *
 * @require myra.js
 * @require jQuery
 * @require jquery.cookie.js
 * @require jquery.fancybox.js
 * @require jquery.dragsort.js
 * @require jquery.jeditable.js
 *
 * Note: dragsort.js does not work with IE8 here.
 */

(function($,myra){
	var MYRA = myra.cfg('path'),
	MYRA_SCRIPTS = myra.cfg('scripts'),
	MYRA_AJAX = myra.cfg('ajax'),

	encodeHTML = function(html){
		return html.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;').replace(/"/g,'&quot;');
	},

	cache_can_edit = null,
	can_edit = function(){
		// Return true if user can edit current directory and its files.
		// Use existance of edit button as an indication the current user has been authorized to edit current directory.
		if (cache_can_edit === null) cache_can_edit = $('.icon-edit').length > 0 ? true : false;
		return cache_can_edit;
	},

	can_rearrange = function(){
		// Return true if user can rearrange thumbnails in current directory.
		// Use existance of script as an indication the current user has been authorized to rearrange current directory.
		return !!jQuery.fn.dragsort;
	},

	make_thumb = function(src,icon_src){
		var name = decodeURIComponent(src.replace(/\?.*/,'').replace(/\/$/,'').replace(/.*\//,'')), ext = name.replace(/.*\./,'');
		//##if (ext && ext != name && /^(jpg|jpeg|gif|png|tif|tiff)$/i.test(ext)) {	//## TODO: restore tiff processing
		if (ext && ext != name && /^(jpg|jpeg|gif|png)$/i.test(ext)) {
			// Display picture thumbnails
			return '<a href="'+MYRA+'/img.php?src='+src+'&slide=1" title="'+encodeHTML(name)+'" rel="thumb" style="background-image:url('+MYRA+'/img.php?src='+src+'&thumb=1)" ondblclick="window.open(\''+src+'\')">&nbsp;</a>';
		}
		else {
			// Display current icon as thumbnail for non-image files
			return '<a href="'+src+'" class="noimg" title="'+encodeHTML(name)+'"><img src="'+icon_src+'"><div class="file-name">'+encodeHTML(name)+'</div></a>';
		}
	},

	save_thumbnail_order = function($el){
		var data = $("#thumb_list a").map(function(){ return $(this).attr("href").replace(/^.*?src=/,'').replace(/&.*/,''); }).get();
		$.post(MYRA_AJAX+"/save-thumbnail-order.php",{ "ids[]": data });
	},

	img_src = function(img_selector){
		// Extract image url from element identified from jquery selector.
		// Myra thumbnails and slides are supplied by the img.php program. Extract src from that url.
		return $(img_selector).attr('src').replace(/.*src=/,'').replace(/&.*/,'');
	},

	img_infobox_defaults = {
		index : 0,
		lastIndex : 0,
		filename : '',
		fancybox : false
	},
	img_infobox_index_str = function(index,total){
		var index_str = index ? 'Image ' + index : '';
		if (index_str && total) index_str += ' / ' + total;
		return index_str;
	},
	img_infobox_html = function(img_selector,opt){
		opt = $.extend({},img_infobox_defaults,{filename : img_src(img_selector).replace(/.*\//,'')},opt);
		var fancybox_close = opt.fancybox ? '$.fancybox.close();' : '',
		fancybox_open = opt.fancybox ? 'setTimeout(function(){$(myra.thumb('+(opt.index-1)+')).click();},500);' : '',
		delete_button = can_edit() ? '<a class="icon-delete" href="#" onclick="'
		 + 'filename=jQuery(\'#imgfilename\').text();'
		 + 'if(confirm(\'Please confirm: Do you want to delete the file \'+filename+\'?\')){'
		    + 'jQuery.get(\''+MYRA_AJAX+'/delete-slide.php?file=\'+encodeURIComponent(filename)+\'&confirm=Yes\',function(data){'
		      + 'if(data==\'File deleted.\'){'
		        + 'jQuery(\'.file-list a[href=\\x22\'+filename+\'\\x22]\').closest(\'tr\').remove();'
		        + 'jQuery(\'#thumb_list a[title=\\x22\'+filename+\'\\x22]\').closest(\'li\').remove();'
		        + '$.fancybox.close();'	// close(), not prev() (cool animation, but user looses place in slide show)
		      + '}else{'
		        + 'alert(data);'
		      + '}'
		    + '})'
		 + '};'
		 + 'return false;'
		 + '" title="Delete original image, slide, and thumbnail.">&nbsp;</a>' : '';

		return ''
		 + '<div class="infobox-wrapper">'
		 + '<div id="img_infobox" class="infobox" style="display:none;">'
		 + '<span id="imgfilename" style="float:left">' + opt.filename + '</span>'
		 + '<a class="icon-close" href="#" title="Close" onclick="jQuery(\'#img_infobox\').hide(\'fast\');">&nbsp;</a>'
		 + '<span id="imgindex" style="clear:left;float:left">' + img_infobox_index_str(opt.index,opt.lastIndex) + '</span>'
		 + delete_button
		 + '<a class="icon-rotate-ccw" href="#" onclick="'+fancybox_close+'myra.rotateThumbCCW('+(opt.index-1)+');'+fancybox_open+'return false;" title="Rotate slide counter-clockwise.">&nbsp;</a>'
		 + '<a class="icon-rotate-cw" href="#" onclick="'+fancybox_close+'myra.rotateThumbCW('+(opt.index-1)+');'+fancybox_open+'return false;" title="Rotate slide clockwise.">&nbsp;</a>'
		 + '<a class="icon-refresh" href="#" onclick="'+fancybox_close+'myra.refreshThumb('+(opt.index-1)+');'+fancybox_open+'return false;" title="Refresh thumbnail and slide.">&nbsp;</a>'
		 + '<a class="icon-download" href="#" onclick="window.open(jQuery(\''+img_selector+'\').attr(\'src\').replace(/.*[?&]src=(.*?)[&].*/,\'$1\')); return false;" title="Download original image.">&nbsp;</a>'
		 + '<a class="icon-magnifier" href="#" onclick="if(jQuery(this).hasClass(\'icon-magnifier\')){myra.magOn();}else{myra.magOff();}return false;" title="Turn image magnifier on.">&nbsp;</a>'
		 + '</div>'
		 + '</div>';
	},
	thumb_array = null;

	$.extend(myra,{
		thumb : function(index){
			if (thumb_array == null) thumb_array = $('#thumb_list a[rel=thumb]');
			return thumb_array[index];
		},

		rotateThumbCCW : function(index){
			// Note: rotating a thumb rotates the slide too on the server side in img.php.

			// Note: background-image css string returned from jQuery 1.8 is like:
			// url("http://...") in IE & FF and url(http://...) in Chrome
			// and IE9 has problems with their re engine once again proving how special they are.
			//$(myra.thumb(index)).css('background-image',$(myra.thumb(index)).css('background-image').replace(/thumb=1.*(['"]?\))/,'thumb=1&rotate=90&s='+Date.now()+'$1'));
			var css = $(myra.thumb(index)).css('background-image').match(/"\)/)
				? $(myra.thumb(index)).css('background-image').replace(/thumb=1.*"\)/,'thumb=1&rotate=90&s='+(new Date()).getTime()+'")')	// for IE
				: $(myra.thumb(index)).css('background-image').replace(/thumb=1.*(['"]?\))/,'thumb=1&rotate=90&s='+(new Date()).getTime()+'$1');
			$(myra.thumb(index)).css('background-image',css);

			// Add serial number to slide url to avoid image rendering from cache.
			$(myra.thumb(index)).attr('href',$(myra.thumb(index)).attr('href').replace(/&s=\d+/,'')+'&s='+(new Date()).getTime());
		},

		rotateThumbCW : function(index){
			// Note: rotating a thumb rotates the slide too.
			//$(myra.thumb(index)).css('background-image',$(myra.thumb(index)).css('background-image').replace(/thumb=1.*(['"]?\))/,'thumb=1&rotate=-90&s='+Date.now()+'$1'));
			var css = $(myra.thumb(index)).css('background-image').match(/"\)/)
				? $(myra.thumb(index)).css('background-image').replace(/thumb=1.*"\)/,'thumb=1&rotate=-90&s='+(new Date()).getTime()+'")')	// for IE
				: $(myra.thumb(index)).css('background-image').replace(/thumb=1.*(['"]?\))/,'thumb=1&rotate=-90&s='+(new Date()).getTime()+'$1');
			$(myra.thumb(index)).css('background-image',css);

			// Add serial number to slide url to avoid image rendering from cache.
			$(myra.thumb(index)).attr('href',$(myra.thumb(index)).attr('href').replace(/&s=\d+/,'')+'&s='+(new Date()).getTime());
		},

		refreshThumb : function(index){
			// Change thumbnail background image to url w/o any rotation.
			//$(myra.thumb(index)).css('background-image',$(myra.thumb(index)).css('background-image').replace(/thumb=1.*(['"]?\))/,'thumb=1&refresh=1&s='+Date.now()+'$1'));
			var css = $(myra.thumb(index)).css('background-image').match(/"\)/)
				? $(myra.thumb(index)).css('background-image').replace(/thumb=1.*"\)/,'thumb=1&refresh=1&s='+(new Date()).getTime()+'")')	// for IE
				: $(myra.thumb(index)).css('background-image').replace(/thumb=1.*(['"]?\))/,'thumb=1&refresh=1&s='+(new Date()).getTime()+'$1');
			$(myra.thumb(index)).css('background-image',css);


			// Add serial number to slide url to avoid image rendering from cache.
			$(myra.thumb(index)).attr('href',$(myra.thumb(index)).attr('href').replace(/&s=\d+/,'')+'&s='+(new Date()).getTime());
		},

		magOn : function(){
			if (! $.hasData($('#fancybox-img')[0])||!$('#fancybox-img').data('imageMagnifier')) {
				$('#fancybox-img').imageMagnifier();
			}

			$('.icon-magnifier')
				.removeClass('icon-magnifier')
				.addClass('icon-magnifier-off')
				.each(function(){
					$(this).attr('title',$(this).attr('title').replace(/ on/,' off'));
				});

			// Adjust fancybox image overlays to avoid interfering with magnifier.
			$('#fancybox-left').css({width:'35px',left:'-24px'});
			$('#fancybox-right').css({width:'35px',right:'-24px'});
			myra.infobox_activate_top_saved=$('#infobox_activate').css('top');
			$('#infobox_activate').css({top:'-18px'});

			$.imageMagnifier.enable();
		},

		magOff : function(){
			$('.icon-magnifier-off')
				.removeClass('icon-magnifier-off')
				.addClass('icon-magnifier')
				.each(function(){
					$(this).attr('title',$(this).attr('title').replace(/ off/,' on'));
				});

			// Return fancybox overlays to original position.
			$('#fancybox-left').css({width:'35%',left:'0px'});
			$('#fancybox-right').css({width:'35%',right:'0px'});
			$('#infobox_activate').css({top:myra.infobox_activate_top_saved});

			$.imageMagnifier.disable();
		},

		changeToThumbView : function(){
			if (! jQuery.imageMagnifier) {
				$.ajax({dateType: 'script', cache: true, async: true, url: MYRA_SCRIPTS+'/jquery.imageMagnifier.js'})
				.done(function(){
					$.imageMagnifier.autoinit = false;	// note: ineffective here, scripts already autoinit-ed (document loaded)
					$.imageMagnifier.enabled = false;	
					$.imageMagnifier.options.loader.image = myra.cfg('theme_images')+'/loader.gif';
					$.imageMagnifier.options.magnifier.height = 120;
					$.imageMagnifier.options.magnifier.width = 120;
					$.imageMagnifier.options.magnifier.cursor = 'crosshair';
					$.imageMagnifier.options.largesrc = function(src){return src.replace(/\bslide=/,'image='); };
				});
			}

			var i,l,href, thumbs = {}, thumb_curr_order = [], seen = {},
			setup_file_name_editor = function(){},
			// Set flags coordinating fancybox and dragsort for Webkit and FF-pre-v4 browsers.
			just_dragged_flag = false, arr,
			is_needed_just_dragged_flag = ($.browser.webkit || ((arr = /Firefox\/(\d+)/.exec(navigator.userAgent)) && parseInt(arr[1],10) < 4));

			if ($('#thumb_list').length == 0) {
				// Construct list of thumbnails from file list generated by mod_autoindex.
				$('.file-list').after('<ul id="thumb_list" class="thumb-list" />');
				$('.file-list table tr').find('td:first').each(function(index,el){
					var href = $(el).find('a').attr('href'), src = $(el).find('img').attr('src');
					if (myra.thumbSortOrder) {
						// Save array of thumbs for sorting
						thumbs[href] = src;
						thumb_curr_order.push(href);
					}
					else {
						// Display thumbs in same order as the file list.
						$('#thumb_list').append( '<li>' + make_thumb(href,src) + '</li>\n');
					}
				});
				if (myra.thumbSortOrder) {
					// Display thumbs in saved sort order
					for (i=0,l=myra.thumbSortOrder.length; i<l; i++) {
						href = myra.thumbSortOrder[i];
						if (thumbs[href]) {
							$('#thumb_list').append( '<li>' + make_thumb(href,thumbs[href]) + '</li>\n');
							seen[href] = true;
						}
					}
					for (i=0,l=thumb_curr_order.length; i<l; i++) {
						href = thumb_curr_order[i];
						if (!seen[href]) {
							$('#thumb_list').append( '<li>' + make_thumb(href,thumbs[href]) + '</li>\n');
						}
					}
				}

				if (can_edit()) {
					$.ajax({dataType: 'script', cache: true, async: true, url: MYRA_SCRIPTS+'/jquery.jeditable.min.js'});
					setup_file_name_editor = function(){
						var filename = $('#imgfilename').text(),
						rename_url = MYRA_AJAX+'/rename.php?filename='+encodeURIComponent(filename),	// put name in url for logs
						theme_images = myra.cfg('theme_images');

						$('#imgfilename').editable(rename_url,{
							name	: 'newname',
							tooltip : 'Click to change...',
							select	: true,
							style	: 'margin:0px; padding:0px;',
							indicator: '<img src="'+theme_images+'/indicator.gif">',
							submit	: '<img src="'+theme_images+'/accept.png">',
							cancel	: '<img src="'+theme_images+'/cancel.png">',
							submitdata : {filename : filename},
							method  : 'POST',
							callback: function(text,opt){
								var newfilename = text;
								// Note: For special characters, encodeURIComponent uses capital letter codes whereas
								// mod_autoindex and php uses lower case letter codes. (e.g. %c2%ac vs %C2%AC)
								// Encode filename so that it can be located by searching href attributes, and check both encodings.
								var encoded_filename_lc = encodeURIComponent(filename).replace(/%[A-Z0-9][A-Z0-9]/g,function(s){return s.toLowerCase();}),
								encoded_filename = encodeURIComponent(filename),
								encoded_newname = encodeURIComponent(newfilename);

								$('.file-list a[href="'+encoded_filename+'"], .file-list a[href="'+encoded_filename_lc+'"]')
									.attr('href',encoded_newname)
									.html(function(index,oldhtml){
										if (! /<img/.test(oldhtml)) {
											return newfilename;
										}
									});
								$('#thumb_list a[title="'+filename+'"]')
									.attr('title',newfilename)
									.attr('href',function(){
										return $(this).attr('href').replace(/src=.*?&/,'src='+encoded_newname+'&');
									})
									.css('background-image',function(){
										return $(this).css('background-image').replace(/src=.*?&/,'src='+encoded_newname+'&');
									});
								// save new file name as old file name for next time
								opt.target = opt.target.replace(/=.*/,'') + encodeURIComponent(newfilename);	// target is rename_url
								opt.submitdata.filename = newfilename;
							}
						});
					}
				}

				// Setup slideshow links
				$('#thumb_list a[rel=thumb]').fancybox({
					overlayShow	: false,
					transitionIn	: 'elastic',
					transitionOut	: 'elastic',
					centerOnScroll	: true,
					titleFormat	: function(title, currentArray, currentIndex, currentOpts){
						return '<div id="fancybox-title-float">' +
							'<div id="infobox_activate" onmouseover="$(\'#img_infobox\').show(\'fast\');"></div>' +
							img_infobox_html('#fancybox-img',{
								filename	: title,
								index		: currentIndex + 1,
								lastIndex	: currentArray.length,
								fancybox	: true
							}) +
							'</div>';
					},
					onStart		: function(selectedArray, selectedIndex, selectedOpts){
								// Return false or fancybox options object.

								// Ignore click if dragsort() just finished.
								if (is_needed_just_dragged_flag && just_dragged_flag) {
									just_dragged_flag = false;
									return false;
								}
							},
					onComplete	: function(selectedArray, selectedIndex, selectedOpts){
								$('#fancybox-img').removeData('imageMagnifier');	// start fresh w. new img element
								if ($.imageMagnifier.enabled) myra.magOn();

								setup_file_name_editor();

								// Shortcut to downloading (opening) original image
								$('#fancybox-img').dblclick(function() {
									window.open($(this).attr('src').replace(/.*[?&]src=(.*?)[&].*/,'$1'));
								});
							}
				});

				if (can_rearrange()) {
					// Allow thumbnails to be sorted by drag and drop
					$("#thumb_list").dragsort({
						dragSelector	: "a",
						dragEnd		: function(changed){
									if (changed) save_thumbnail_order(this);

									// Cancel fancybox actions for Webkit and FF-pre-v4 browsers
									if (is_needed_just_dragged_flag) just_dragged_flag = true;
								}
					});
				}

			}

			$('.file-list').hide();
			$('#thumb_list').show();
			$.cookie('myraView','thumb',{path:location.pathname,expires:180});
		},

		changeToListView : function(){
			$('#thumb_list').hide();
			$('.file-list').show();
			// delete cookie by setting it to null
			$.cookie('myraView',null,{path:location.pathname,expires:180});
		}
	});

	$.fn.stream = function() {
		// Change video urls into streaming urls using /myra/stream.php
		$(this).each(function(){
			$(this).attr('href',$(this).attr('href').replace(/(.*)/,function(str,p1){return MYRA+'/stream.php?src='+encodeURIComponent(p1)}));
		});
		return this;
	};

	$(function(){
		if ($('.icon-thumbnail-view').length > 0) {
			if ($.browser.msie || $.browser.opera)	pageshow = 'load';	// have no pageshow event
			else					pageshow = 'pageshow';	// use pageshow so event fires upon using back button

			// Setup event to show proper list view or thumbnails, even on cached pages' redisplay.
			$(window).bind(pageshow,function(event){
				if ($.cookie('myraView') == 'thumb') {
					myra.changeToThumbView();
				}
				else {
					myra.changeToListView();
				}
			});
		}
	});
})(jQuery,myra);
