<?php
/*
 * Myra Configuration
 *
 * System configuration settings go here. Site settings should go
 * into lib/config.inc.php instead and local settings should go
 * into myra-local/config.inc.php.
 */

// Site configuration.
include_once dirname(__FILE__).'/config.inc.php';

// Include local configuration settings.
include_once 'myra-local/config.inc.php';

// Program configuration (allow possible override).
$GLOBALS['ERROR_URL'] = $GLOBALS['ERROR_URL'] ? $GLOBALS['ERROR_URL'] : $GLOBALS['MYRA'].'/error.php';
$GLOBALS['ERROR_DIALOG_URL'] = $GLOBALS['ERROR_DIALOG_URL'] ? $GLOBALS['ERROR_DIALOG_URL'] : $GLOBALS['MYRA'].'/dlg/error.php';
$GLOBALS['SIGNOUT_URL'] = $GLOBALS['SIGNOUT_URL'] ? $GLOBALS['SIGNOUT_URL'] : $GLOBALS['MYRA'].'/signin/signout.php';
$GLOBALS['BAD_BROWSER_URL'] = $GLOBALS['BAD_BROWSER_URL'] ? $GLOBALS['BAD_BROWSER_URL'] : $GLOBALS['MYRA'].'/bad-browser.php';

// Set to login user or web server user
$GLOBALS['REMOTE_USER'] = isset($_SERVER['PHP_AUTH_USER']) ? $_SERVER['PHP_AUTH_USER'] : array_shift(posix_getpwuid(posix_geteuid()));

// Export configurations into the environment for use by the MYRA_SUPPORT programs.
// Note: if using sudo, then the following environment variables must also be defined
// in /etc/sudoers with the statement: Defaults env_keep += "..."
putenv('MYRA_PATH='.$GLOBALS['MYRA_PATH']);
putenv('MYRA_LOCAL_PATH='.$GLOBALS['MYRA_LOCAL_PATH']);
putenv('MYRA_SUPPORT_PATH='.$GLOBALS['MYRA_SUPPORT_PATH']);
putenv('ORG_NAME='.$GLOBALS['ORG_NAME']);
putenv('REMOTE_USER='.$GLOBALS['REMOTE_USER']);
putenv('PASSWORD_FILE='.$GLOBALS['PASSWORD_FILE']);
putenv('GROUP_FILE='.$GLOBALS['GROUP_FILE']);
putenv('NEW_FOLDER_MODE='.$GLOBALS['NEW_FOLDER_MODE']);
putenv('NEW_FILE_MODE='.$GLOBALS['NEW_FILE_MODE']);
putenv('INDEXDB='.$GLOBALS['INDEXDB']);
putenv('INDEXDB_NAME='.$GLOBALS['INDEXDB_NAME']);
putenv('LOG_DIR='.$GLOBALS['LOG_DIR']);

// The following environment variables do not have to be exported in /etc/sudoers.
putenv('ARCHIVE_FILES='.$GLOBALS['ARCHIVE_FILES']);
putenv('ARCHIVE_DIR='.$GLOBALS['ARCHIVE_DIR']);
putenv('USE_SUDO='.$GLOBALS['ESCALATE_EDITOR_PRIVILEGES']);
?>
