<?php
/**
 * File access functions
 *
 * This version of file functions utilize scripts in Myra support directory so
 * web server privileges can optionally be escalated to manipulate files.
 */

include_once dirname(__FILE__).'/config.php';

function create_folder($folder_name,$dir=".") {
	if (chdir($dir)) {
		if (mkdir($file,$GLOBALS['NEW_FOLDER_MODE']) !== false) {
			return true;
		}
		elseif ($GLOBALS['ESCALATE_EDITOR_PRIVILEGES']) {
			warn("create_file: Escalating privileges to create a new folder for ${GLOBALS['REMOTE_USER']}");
			$filearg = escapeshellarg($folder_name);
			$dirarg = escapeshellarg($dir);
			system("{$GLOBALS['MYRA_SUPPORT_PATH']}/scripts/create_folder $filearg $dirarg 2>&1",$ret);
			if (! $ret) {
				return true;
			}
			warn("create_folder: script returned errno $ret");
		}
	}
	warn("create_folder: Cannot make the folder $folder_name in the directory $dir");
	return false;
}

function write_file($file,$data='') {
	if (file_put_contents($file,$data) !== false) {
		chmod($file,$GLOBALS['NEW_FILE_MODE']);
		return true;
	}
	elseif ($GLOBALS['ESCALATE_EDITOR_PRIVILEGES']) {
		warn("write_file: Escalating privileges to write file for ${GLOBALS['REMOTE_USER']}");
		$filearg = escapeshellarg($file);
		$fd = popen("{$GLOBALS['MYRA_SUPPORT_PATH']}/scripts/write_file $filearg 2>&1",'w');
		if ($fd) {
			fwrite($fd,$data);
			pclose($fd);
			return true;
		}
	}
	warn("write_file: Cannot write to the file $file.");
	return false;
}

function rename_file($file,$new_name) {
	if (rename($file,$new_name) !== false) {
		return true;
	}
	elseif ($GLOBALS['ESCALATE_EDITOR_PRIVILEGES']) {
		warn("rename_file: Escalating privileges to rename file for ${GLOBALS['REMOTE_USER']}");
		$filearg = escapeshellarg($file);
		$namearg = escapeshellarg($new_name);
		system("{$GLOBALS['MYRA_SUPPORT_PATH']}/scripts/rename_file $filearg $namearg 2>&1",$ret);
		if (! $ret) {
			return true;
		}
		warn("rename_file: errno $ret");
	}
	warn("rename_file: Cannot rename the file $file.");
	return false;
}

function delete_file($file) {
	if (unlink($file) !== false) {
		return true;
	}
	elseif ($GLOBALS['ESCALATE_EDITOR_PRIVILEGES']) {
		warn("delete_file: Escalating privileges to delete file for ${GLOBALS['REMOTE_USER']}");
		$filearg = escapeshellarg($file);
		system("{$GLOBALS['MYRA_SUPPORT_PATH']}/scripts/delete_file $filearg 2>&1",$ret);
		if (! $ret) {
			return true;
		}
		warn("delete_file: errno $ret");
	}
	warn("delete_file: Cannot delete the file $file.");
	return false;
}

function archive_file($file,$msg='') {
	if (! $GLOBALS['ARCHIVE_FILES']) return;

	// Save file in an archive (usually before changing it).
	$filearg = escapeshellarg($file);
	$msgarg = $msg ? '-c'.escapeshellarg($msg) : '';
	system("{$GLOBALS['MYRA_SUPPORT_PATH']}/scripts/archive_file $msgarg $filearg 2>&1",$ret);
	if ($ret) {
		warn("archive_file: Cannot archive $file. (errno $ret)");
	}
}

function extension($file) {
	return strpos($file,'.') !== false ? strtolower(end(explode(".", $file))) : '';
}
?>
