<?php
/*
 * Change my password
 *
 * This page is located in a directory where there is a .htaccess file containing the
 * "Require valid-user" stanza in it in order to force Apache Basic Authorization.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.auth.php';

$session = Session::getInstance();

$user = authenticate_user() or die_unauthenticated();

$username = $session->user->username() or $username = $GLOBALS['REMOTE_USER'] or $username = '';

$return_url = isset($session->return_url) ? $session->return_url : '/';
unset($session->return_url);
$u_return_url = rawurlencode_path($return_url);

$script = <<<End_Of_Javascript
<script type="text/javascript">
//<![CDATA[
jQuery(function($){
	$('form').submit(function(event){
		// Stop form from submitting normally.
		event.preventDefault(); 
		
		// Validate
		if ($('input[name=new_password]').val() != $('input[name=confirm_password]').val()) {
			$('.messages').html('<span class="error">Passwords do not match. Please enter them again.</span>');
			$('input:password:first').select();
			return false;
		}

		// Clear messages
		$('.messages').html('');

		// Submit
		$.post($(this).prop('action'),$(this).serialize())
		 .done(function(data){
			var result = JSON.parse(data);
			if (result['success']) {
				// post results, close window.
				$('.messages').html('<span class="success">Your password has been changed.</span>');
				$('.dialog-buttons').html('<input type="button" value="Continue" onclick="location.href=\'{$u_return_url}\'" />');
				$('input:password').parent().hide();
				$('input[type=button]:first').focus();
			}
			else {
				alert('Password was not saved. '+result['errmsg']);
			}
		})
		 .fail(function(){
			alert('An error occurred when trying to save the password.');
		});
	});

	// Return to sender if canceled.
	$('input:reset').click(function(){
		location.href = '{$u_return_url}';
	});

	// Identify reqired fields
	$('input[required]').after('<img src="'+myra.cfg('theme_images')+'/required.png" title="This field entry is required.">');

	// Focus on first field
	$('input:visible:first').focus();
});
//]]>
</script>

End_Of_Javascript;

$title = "Change My Password - Mystery Ranch";
$page_type = 'dialog-page';
?>
<?php include 'myra/inc/portrait_begin.php'; ?>

<h1>Change My Password</h1>

<div class="dialog">
<div class="change-password">
<form action="<?php echo $GLOBALS['MYRA'] . '/ajax/change-password.php'; ?>" method="post">
<input type="hidden" name="user"  value="<?php echo rawurlencode($username); ?>" />
<div class="section">
<h2>Changing password for <?php echo htmlspecialchars($username); ?></h2>
<div class="messages"></div>
<label>Enter your new password. <input type="password" name="new_password" required="required" /></label>
<label>Confirm your new password. <input type="password" name="confirm_password" required="required" /></label>
</div><!-- .section -->

<div class="dialog-buttons">
 <input type="submit" value="Save" />
 <input type="reset" value="Cancel" />
</div>
</form>
</div><!-- .change-password -->
</div><!-- .dialog -->

<?php include 'myra/inc/portrait_end.php'; ?>
