<?php
/*
 * Sign in page
 *
 * This page is located in a directory where there is a .htaccess file containing the
 * "Require valid-user" stanza in it in order to force Apache Basic Authorization.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/lib.auth.php';

// With Apache Authentication, just getting here means login was successful.

if (isset($_SERVER['PHP_AUTH_USER'])) {
	// Check if referring page is from this domain and if so, redirect back to it immediately.
	$referer_domain = $_SERVER['HTTP_REFERER'] ? preg_replace('|/.*|','',preg_replace('|^https?://|','',$_SERVER['HTTP_REFERER'])) : '';
	$this_domain = $_SERVER['HTTP_HOST'];
	if ($this_domain == $referer_domain) {
		// For Apache authentication, authenticate_user() sets up user session variables.
		$user = authenticate_user() or die_unauthenticated();
		if (preg_replace('/\?.*/','',$_SERVER['HTTP_REFERER']) == my_url()) {
			// Go to home page.
			header('Location: /');
		}
		else {
			// Redirect back to previous page.
			header('Location: '.$_SERVER['HTTP_REFERER']);
		}
		exit;
	}
}

$title = "Sign in - Mystery Ranch";
$page_type = 'dialog-page';
?>
<?php include 'myra/inc/portrait_begin.php'; ?>

<h1>Sign in</h1>

<p>By reaching this page you have successfully signed into Mystery Ranch intranet.</p>

<p>Welcome. Please continue.</p>

<div class="dialog-buttons">
<button class="dialog" onclick="location.href='/'">Continue</button>
</div>

<?php include 'myra/inc/portrait_end.php'; ?>
