<?php
/*
 * Myra Sign Out Page
 *
 * Security uses Apache Basic authentication and there is no way that the server
 * knows that the authentication keys have been discarded. The only way a user
 * can successfully log out is by exiting the browser completely. This program
 * simply displays such a message and can be used as a sample for a customized
 * sign out page.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.common.php';

$session = Session::getInstance();

$title = "Sign Out";
$page_type = 'dialog-page';

// Note: As authentication token is stored in the browser, the web server will allow access to any
// of this user's documents but it does shut down anything going through Myra.
$plea_html = ! (isset($session->logged_out) && $session->logged_out) ? '' : <<<End_Of_HTML
<div class="warning">
You are still signed in. Please <strong>Exit</strong> this browser to complete signing out.
</div>

End_Of_HTML;

// Invalidate current session variables.
$session->logged_out = true;
unset($session->user);		// remove user credentials
unset($session->contexts);	// clear out any saved contexts for ajax
?>

<?php include 'myra/inc/error_begin.php'; ?>

<div class="dialog">
<h1>Sign out</h1>

<?php echo $plea_html; ?>
<p>Because your password has been temporarily stored in your browser for your convenience,
the only way to really successfully log out of this system is to completely exit your browser program.
That includes all tabs and windows.
This sign out process will not be complete until you Exit your browser.</p>
<p>Please <strong>Exit</strong> your browser program now.</p>

<div class="dialog-buttons">
<button onclick="window.close()">OK</button>
</div>

<!--
<h2>How to Exit Your Browser Program</h2>
<h3>General Instructions</h3>
<p>On PCs and laptops, the browser program ends when the last window closes. Some browsers have 'Exit' menu selections to close all windows, other browsers like IE require you to close each window yourself.</p>
<p>On phones and tablets, you need to access the list of programs that are running on the device and manually terminate the program from there.</p>

<h3>Exit Internet Explorer</h3>
<p>To exit IE you need to close every open window by clicking the X icon in the upper right corner of the window.</p>

<h3>Exit Firefox</h3>
<p>To exit the Firefox browser, click the Firefox menu (on older versions click the File menu) and select 'Exit'.</p>

<h3>Exit Chrome</h3>
<p>To exit Google Chrome, click the tools menu (the wrench icon in the upper right portion of the browser window) and select 'Exit'.</p>

<h3>Exit Safari</h3>
<p>To exit the Safari browser on the Mac, click the Safari menu on the top menu bar and select 'Exit'.</p>
<p>To exit the Safari browser on the PC close every window by clicking the X icon in the upper right corner of the window.</p>

<h3>Exit iPhone and iPad Browser</h3>
<p>To exit your browser on your iPad and iPhone, do the following:</p>
<ol>
 <li>Click Home button.</li>
 <li>Double-click the Home button again.</li>
 <li>Touch and hold the Safari icon till it jiggles.</li>
 <li>Click the minus button on the upper left corner of the Safari icon.</li>
 <li>Double-click the Home button to return to your home screen.</li>
</ol>
<p>
-->

</div><!-- .dialog -->

<?php include 'myra/inc/error_end.php'; ?>
