<?php
/*
 * Sign out page
 *
 * This page is located in a directory where there is a .htaccess file containing the
 * "Require valid-user" stanza in it in order to force Apache Basic Authorization.
 */

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.auth.php';

debug('signout: PHP_AUTH_USER='.$_SERVER['PHP_AUTH_USER']);

$session = Session::getInstance();

if (isset($_SERVER['PHP_AUTH_USER'])) {
	if (isset($session->authenticated_user)) {
		if ($session->authenticated_user == $_SERVER['PHP_AUTH_USER']) {
			// Logout

			$browser = browser();

			// Note: IE goes through the motions of displaying authentication dialog
			// but does not invalidate session if the user cancels. User's can still
			// go to protected urls without signing in again.
			// The work arround is to use special IE Javascript and if that fails,
			// divert IE users to the signout page as often as possible. 
			### TODO: test windows phones, do they not log out like androids???
			if ($browser == 'ie') {
				print <<<End_Of_HTML
<html><head><meta http-equiv="refresh" content="0; url=signout-ie.php"></head><body></body></html>
End_Of_HTML;
				exit;
			}

			$session->destroy();

			// Because of Safari's over exuberance in retrieving 401.php whenever a
			// directory with a .htaccess directive of Require valid-user, even if 
			// user validated or not, and because Safari caches the url invoking the
			// 401 header and would not call this program again on the next signout,
			// redirect to another url which will return the 401 header from there.
			if ($browser == 'safari') {
				print <<<End_Of_HTML
<html><head><meta http-equiv="refresh" content="0; url=signout-safari.php"></head><body></body></html>
End_Of_HTML;
				exit;
			}

			// Normal case. Issue the 401 header to cause the browser to clear its
			// saved digest and re-display the login screen.
			header('HTTP/1.1 401 Unauthorized');
			header('WWW-Authenticate: Basic realm="'.$GLOBALS['AuthName'].'"');
			// Include html that is to be displayed if user cancels the login screen.
			// Note: This does not work for Safari which always invokes 401 Error Document.
			print <<<End_Of_HTML
<html><head><meta http-equiv="refresh" content="0; url={$GLOBALS['AFTER_LOGOUT_URL']}"></head><body></body></html>
End_Of_HTML;
			exit;
		}
		else {
			// User logged out but re-signed in as a different valid user.
			authenticate_user() || exit_next($GLOBALS['MYRA'].'/401.php');
			// Redirect to home page.
			exit_next('/');
		}
	}
	else {
		// User logged out but re-signed in as a valid user.
		authenticate_user() || exit_next($GLOBALS['MYRA'].'/401.php');
		// Redirect to home page.
		exit_next('/');
	}
}
else {
	// This should never happen.
	warn('signin/signout: no PHP_AUTH_USER is defined. Is the signin directory protected with "Require valid-user"?');
	exit_next('/');
}
