<?php
/*
 * Set session cookie and then redirect back to where we came.
 */

include_once 'myra/lib/class.Session.php';
$session = Session::getInstance();

// Note: mod_autoindex thwarts sending header records from its php header
// and footer programs which thwarts setting cookies like the php session
// cookie. This program simply starts a PHP session setting a cookie and
// then redirects back to the page that sent us here.
// A token t must be given that encodes the return address so we're not
// spoofed.

include_once 'myra/lib/lib.common.php';

$r = isset($_REQUEST['r']) ? rawurldecode($_REQUEST['r']) : $_SERVER['HTTP_REFERER'];
$t = isset($_REQUEST['t']) ? $_REQUEST['t'] : '';

debug('start.php: r='.$r.', HTTP_REFERER='.$_SERVER['HTTP_REFERER']);

if ($r) {
	if ($t != token($r)) exit_forbidden();

	// Add flag to return address for loop prevention.
	$r .= (strpos($r,'?') === false ? '?' : '&') . 'start=1';
	$r = sanitize_url($r);
	print <<<End_Of_HTML
<html><head><meta http-equiv="refresh" content="0; url=$r"></head><body></body></html>
End_Of_HTML;
}
else {
	warn('start.php: Called without a return address.');
}
exit;
?>
