<?php
/**
 * stream -- Output a simple html file for streaming the given video file.
 *
 * TODO: automatically create thumbnails from the video file? or remove thumb option.
 */

$SECURITY_STRICT_VIDEO_SRC = true;	// restrict video src paths to current directory

include_once 'myra/lib/config.php';
include_once 'myra/lib/class.Session.php';
include_once 'myra/lib/lib.common.php';
include_once 'myra/lib/lib.file.php';

$session = Session::getInstance();

$src		= isset($_REQUEST['src'])	? $_REQUEST['src']	: '';	// required
$width		= isset($_REQUEST['width'])	? $_REQUEST['width']	: $GLOBALS['VIDEO_WIDTH'];
$height		= isset($_REQUEST['height'])	? $_REQUEST['height']	: $GLOBALS['VIDEO_HEIGHT'];
$thumb		= bool($_REQUEST['thumb']);

if (context_id($_SERVER['HTTP_REFERER']) != $session->context) {
	//switch_context($_SERVER['HTTP_REFERER']) or exit_forbidden("src=$src, session=".$session->context);
	switch_context($_SERVER['HTTP_REFERER']) or exit_dialog_error("Access to video is restricted. Please refresh your screen and try again.");
}

// Sanitize src parameter.
$src = rawurldecode($src);
if (preg_match('|\.\./|',$src)) {
	warn("Relative path names using /../ are not allowed. src=$src");
	if ($thumb) {
		header('Content-type: image/png');
		print file_get_contents($GLOBALS['MYRA_THEMES_PATH'].'/'.my_theme().'/images/thumb-403.png');
		exit;
	}
	//exit_forbidden();
	exit_dialog_error("Access to video source is restricted.");
}
if ($SECURITY_STRICT_VIDEO_SRC) $src = basename($src);

// Set full path of image src.
$file = $session->curr_dir . DIRECTORY_SEPARATOR . $src;

if (! is_readable($file)) {
	if ($thumb) {
		header('Content-type: image/png');
		print file_get_contents($GLOBALS['MYRA_THEMES_PATH'].'/'.my_theme().'/images/thumb-404.png');
	}
	else {
		header("HTTP/1.0 404 Not Found");
	}
	//exit;
	exit_dialog_error("Video source cannot be found.");
}

if ($thumb) {
	header('Content-type: image/png');
	### TODO: generate thumb image automatically?
	print file_get_contents($GLOBALS['MYRA_THEMES_PATH'].'/'.my_theme().'/images/thumb-404.png');
	exit;
}

$src_url = rawurlencode_path(preg_replace('|'.$GLOBALS['DOCUMENT_ROOT'].'|','',$session->curr_dir) . DIRECTORY_SEPARATOR . $src);

// Stream video
?>
<!doctype html>
<html lang="en-US" xmlns="http://www.w3.org/1999/xhtml">
<head>
<style>
body { margin:0; padding:0; }
</style>
</head>
<body>
<div class="dialog">
<div style="width:<?php echo $width; ?>px; margin:0 auto;">

<?php
switch (extension($src)) {
case 'swf':	// Flash
case 'flv':	// Flash
case 'f4v':	// Flash h.264
// Flash player
	print <<< End_Of_HTML
<embed type="application/x-shockwave-flash" src="$src_url" width="$width" height="$height" play="true" loop="false" quality="high" pluginspage="http://www.macromedia.com/go/getflashplayer"></embed>
End_Of_HTML;
	break;

// Windows media player
case 'avi':	// Microsoft
case 'wmv':	// Microsoft
	$height += 30;		// Allow space for control bar
	print <<< End_Of_HTML
<embed type="application/x-mplayer2" src="$src_url" NAME="MediaPlayer" width="$width" height="$height" ShowControls="1" ShowStatusBar="1" ShowDisplay="1" autostart="0"></embed>
End_Of_HTML;
	break;

// Quicktime player
case 'mov':	// Apple Quicktime
case 'mp4':	// MPEG 4
case 'm4v':	// MPEG 4
case '3gp':	// MPEG 4
	$height += 20;		// Allow space for control bar
	print <<< End_Of_HTML
<embed src="$src_url" width="$width" height="$height" autoplay="true" controller="true" loop="false" pluginspage="http://www.apple.com/quicktime/download/"></embed>
End_Of_HTML;
	break;

default:
// File download
	print <<< End_Of_HTML
<script>location.href="$src_url"</script>
End_Of_HTML;
}
?>

</div>
</div><!-- .dialog -->
</body>
</html>
