/*
 * Initialize page for theme.
 *
 * @require myra.js
 */

(function($){
	// Content buttons in this theme are icons w/o text.
	$(function(){ $('.content-buttons a').text(''); });	// accommodate IE8

	// Initialize accordion menus if defined on page.
	$(function(){
		if ($('.nav.accordion').length > 0) {
			// Setup navigation list for accordion menu.
			$('.nav.accordion>ul').addClass('collapsible');
			$('.nav.accordion>ul ul').addClass('acitem collapsible');
			$('.nav.accordion a.current').closest('li').addClass('expand');

			// Set current menu item from this page's url.
			var href = location.href;
			// Strip host from url as menu links do not include host name.
			//href = href.replace(RegExp('.*?'+location.host),'');
			$('.nav.accordion a[href="'+href+'"]')
				.addClass('current')
				.parentsUntil('.nav')
				.each(function(){
					$(this).addClass('current');
				});

			// Setup hover effect.
			(function(){
				var delay = 500;       // milliseconds
				$('.nav.accordion li').each(function(){
					if ($('.acitem',this).length > 0) {
						$(this)
						.mouseenter(function(e){
							var $el = $(this);
							$el.data('mouseStillOver',true);
							$el.data('timer',setTimeout(function(){
								if ($el.data('mouseStillOver') && ! $('.acitem',$el).is(':visible')) {
									$el.click();
								}
							},delay));
						})
						.mouseleave(function(){
							$(this).data('mouseStillOver',false);
							clearTimeout($(this).data('timer'));
						})
						.click(function(){
							$(this).data('mouseStillOver',false);
							clearTimeout($(this).data('timer'));
						});
					}
				});
			})();

			// Load and activate accordion menus.
			$.ajax({dataType: 'script', cache: true, async: true, url: myra.cfg('theme_scripts')+'/accordion-menu.js'});
		}
	});

	// Show breadcrumbs.
	$.ajax({dataType: 'script', cache: true, async: true, url: myra.cfg('theme_scripts')+'/breadcrumbs.js'})
	.done(function() {
		$(function(){
			$('.header').after('<div class="breadcrumbs">'+breadcrumbs()+'</div>\n');
		});
	});

	// Add a go-to-top-of-page button.
	$(function(){
		var $w = $(window),
		$top = $('<a/>')
			.addClass('top-button')
			.attr({
				id : 'top_button',
				title : 'Go to top of page.',
				text : 'Top'
			})
			.click(function(){
				$w.scrollTop(0);
				return false;
			}),
		show_top_button = function() {
			if ( $('body').height() > $w.height()) {
				if ($w.scrollTop() > 10) {
					$top.show();
				}
				else {
					$top.hide();
				}
			}
			else {
				$top.hide();
			}
		};
		$('.footer').prepend($top);
		$w.resize(show_top_button).scroll(show_top_button);
		show_top_button();
	});

	// Change background picture depending upon window width.
	$(function(){
		if ($(document).width() >= 1600) {
			$('body').css({'background-image':'url('+myra.cfg('theme_images')+'/myra-bw-lg.jpg)'});
		}
	});
})(jQuery);
